<?php
/**
 * ClassName  LogoutSuccess.
 * @developer: Larisa Groza
 * @company: BitStone
 */
namespace KPIs\Customer\Controller\Account;

use Magento\Customer\Model\Session;

class Logout extends \Magento\Customer\Controller\Account\Logout
{
    /**
     * @var string
     */
    protected $_callback;

    /**
     * @var Session
     */
    protected $session;

    /**
     * Customer logout action
     *
     * @return \Magento\Framework\Controller\Result\Redirect|void
     */
    public function execute()
    {
        $request = $this->getRequest();
        $customerId = $request->getParam('customer_id');
        $kpiViews = $request->getParam('kpi_views_customer');

        if (isset($customerId) && isset($kpiViews)) {
            $this->_eventManager->dispatch(
                'kpis_views_sync_customer_logout',
                ['customer_id' => $customerId, 'kpi_views_customer' => $kpiViews]
            );
        }

        $callback = $request->getParam('callback');
        if (!isset($callback)) {
            return parent::execute();
        }

        $this->_callback = $callback;

        if ($this->session->isLoggedIn()) {
            $this->session->logout();
        }

        return $this->_jsonPExit();
    }

    /**
     * Callback - When logout send to SmartKpiInstitute.
     */
    protected function _jsonPExit()
    {
        header('Content-type: application/javascript');
        echo "{$this->_callback}()";
        exit();
    }
}
