<?php

namespace KPIs\Customer\Model\Config\Source;

class CustomerAccess extends \Magento\Eav\Model\Entity\Attribute\Source\AbstractSource
{
    /**
     * @var \KPIs\Customer\Helper\Data
     */
    protected $helper;

    /**
     * CustomerAccess constructor.
     * @param \KPIs\Customer\Helper\Data $helper
     */
    public function __construct(
        \KPIs\Customer\Helper\Data $helper
    )
    {
        $this->helper = $helper;
    }

    public function getAllOptions()
    {
        $this->_options = [
                ['label' => 'Choose Access..', 'value' => ''],
            ];
        foreach ($this->helper->getAllCustomerAccess() as $label => $value) {
            $tmp = ['label' => $label, 'value' => $value];
            array_push($this->_options, $tmp);
        }
        return $this->_options;
    }

}