<?php
namespace KPIs\Invoice\Observer;


use Magento\Framework\Event\ObserverInterface;
use KPIs\Invoice\FPDF\FPDF;
use Magento\Store\Model\StoreManager;
require_once("/home/marketplaceindic/public_html/PHPMailer/class.phpmailer.php");
require_once("/home/marketplaceindic/public_html/PHPMailer/class.smtp.php");
require_once("/home/marketplaceindic/public_html/FPDF/FPDF.php");

class GenerateInvoice implements ObserverInterface
{

    protected $_objectManager;
    protected $_responseFactory;
    protected $_url;
    private $messageManager;
    /**
     * @param \Magento\Framework\ObjectManagerInterface $objectManager
     */
    public function __construct(
        \Magento\Framework\ObjectManagerInterface $objectManager,
        \Magento\Framework\App\ResponseFactory $responseFactory,
        \Magento\Framework\UrlInterface $url,
        \Magento\Framework\Message\ManagerInterface $messageManager,
         StoreManager $storeManager

    ) {
        $this->_objectManager = $objectManager;
        $this->_responseFactory = $responseFactory;
        $this->_url = $url;
        $this->messageManager = $messageManager;
        $this->storeManager = $storeManager;

    }

    /**
     * customer register event handler
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     */
    public function execute(\Magento\Framework\Event\Observer $observer)
    {


        $invoice = $observer->getEvent()->getInvoice();
        $order = $invoice->getOrder();
        $orderID = $order->getEntityId();

        $objectManager =   \Magento\Framework\App\ObjectManager::getInstance();
        $connection = $objectManager->get('Magento\Framework\App\ResourceConnection')->getConnection('\Magento\Framework\App\ResourceConnection::DEFAULT_CONNECTION');
        $result = $connection->fetchAll("select if(s.customer_address_id  is null,0,s.customer_address_id) as cnt from sales_order_address s where s.parent_id = '{$orderID}'");

        if($result[0]['cnt'] == 0){

            $getOrderInfo = $connection->fetchAll("
 SELECT
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = tab.entity_id and caev.attribute_id = 34) as telefon,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = tab.entity_id and caev.attribute_id = 224) as registrul_comertului,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = tab.entity_id and caev.attribute_id = 225) as cod_fiscal,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = tab.entity_id and caev.attribute_id = 227) as banca,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = tab.entity_id and caev.attribute_id = 228) as ci_serie_nr,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = tab.entity_id and caev.attribute_id = 229) as nume_delegat,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = tab.entity_id and caev.attribute_id = 226) as cont,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = tab.entity_id and caev.attribute_id = 238) as cnp,
(select if(caei.value = 6,'Companie','Persoana fizica') from customer_address_entity_int caei where caei.entity_id = tab.entity_id  and caei.attribute_id = 223) as tip_cumparator,
(select cad.city from customer_address_entity cad where cad.entity_id = tab.entity_id) as oras,
(select cad.street from customer_address_entity cad where cad.entity_id = tab.entity_id) as strada,
(select cad.region from customer_address_entity cad where cad.entity_id = tab.entity_id) as regiune,
tab.*
FROM (SELECT s.customer_id,
s.customer_firstname,
s.customer_lastname,
s.customer_email,
date(s.created_at) as created_at, 
s.increment_id AS nr,
si.qty_ordered,
si.price,
si.price * si.qty_ordered as pret_produs,
si.name as nume_produs,
(
SELECT c.entity_id
FROM customer_address_entity c
WHERE c.parent_id = s.customer_id AND c.created_at = (
SELECT MAX(cae.created_at)
FROM customer_address_entity cae
WHERE cae.parent_id = s.customer_id)) AS entity_id
FROM sales_order s
JOIN sales_order_item si ON s.entity_id = si.order_id
WHERE s.entity_id = '{$orderID}' ) as tab
");
        }else {
            $getOrderInfo = $connection->fetchAll("
SELECT
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = '{$result[0]['cnt']}' and caev.attribute_id = 34) as telefon,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = '{$result[0]['cnt']}' and caev.attribute_id = 224) as registrul_comertului,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = '{$result[0]['cnt']}' and caev.attribute_id = 225) as cod_fiscal,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = '{$result[0]['cnt']}' and caev.attribute_id = 227) as banca,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = '{$result[0]['cnt']}' and caev.attribute_id = 228) as ci_serie_nr,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = '{$result[0]['cnt']}' and caev.attribute_id = 229) as nume_delegat,
(select caev.value from customer_address_entity_varchar caev where caev.entity_id = '{$result[0]['cnt']}' and caev.attribute_id = 226) as cont,
(select
(select cc.value from customer_address_entity_varchar cc where cc.entity_id =  (select max(rad.entity_id)) and cc.attribute_id = 238) as cnp
from (
select * from customer_address_entity_varchar caev
where caev.entity_id in
(SELECT
cae.entity_id
FROM customer_address_entity cae
WHERE cae.parent_id = (
SELECT
cae.parent_id
FROM customer_address_entity cae
WHERE cae.entity_id = '{$result[0]['cnt']}'
))  and caev.attribute_id = 238 ) as rad) as cnp,
(select if(caei.value = 6,'Companie','Persoana fizica') from customer_address_entity_int caei where caei.entity_id = '{$result[0]['cnt']}'  and caei.attribute_id = 223) as tip_cumparator,
(select cad.city from customer_address_entity cad where cad.entity_id = '{$result[0]['cnt']}') as oras,
(select cad.street from customer_address_entity cad where cad.entity_id = '{$result[0]['cnt']}') as strada,
(select cad.region from customer_address_entity cad where cad.entity_id = '{$result[0]['cnt']}') as regiune,
tab.*
FROM (SELECT s.customer_id,
s.customer_firstname,
s.customer_lastname,
s.customer_email,
date(s.created_at) as created_at,
s.increment_id AS nr,
si.qty_ordered,
si.price,
si.price * si.qty_ordered as pret_produs,
si.name as nume_produs
FROM sales_order s
JOIN sales_order_item si ON s.entity_id = si.order_id
WHERE s.entity_id = '{$orderID}') as tab
");
        }

//        echo "<pre>";
//        print_r($getOrderInfo);
//        exit;


        $image1 = $_SERVER['DOCUMENT_ROOT']."/pub/media/logo/default/AcumenLogoNew.png";


        $pdf = new \FPDF();
        $pdf->AddPage();
        $pdf->SetFont('Arial','B',16);
        $pdf->SetTitle("Factura fiscala");
        $pdf->Image($image1,10,6);
        $pdf->SetDrawColor(31,67,121);
        $pdf->Line(10,30,200,30);
        $pdf->SetFont("Arial","",10);
        $pdf->Text(10,35,"S.C. Integerperform S.R.L.");
        $pdf->Text(10,40,"Sediul Social: Aleea Detunata, Nr. 1, Ap. 7, Cluj-Napoca, Jud. Cluj, cod postal 400434");
        $pdf->Text(10,45,"Punct de lucru: Str. Bistritei nr. 49A, et. 1, Cluj-Napoca, jud. Cluj, cod postal 400434");
      //  $pdf->Text(10,50,"loc. Cluj-Napoca, jud. Cluj, cod postal 400434");
        $pdf->Text(10,55,"Tel/Fax: +40 264 414 360");
        $pdf->Text(10,60,"o	Nr. Reg. Com.: J12/1644/2002, C.I.F.: RO14852037");
        $pdf->Text(10,65,"Cont LEI: RO97 INGB 0000 9999 0325 8753");
        $pdf->Text(10,70,"Capital Social: 200 RON");
        $pdf->SetFont("Arial","B",10);
        $pdf->Text(10,80,"Cumparator: {$getOrderInfo[0]['customer_firstname']} {$getOrderInfo[0]['customer_lastname']}");
        $pdf->Text(10,85,"Nr.ord.reg.com./an.: {$getOrderInfo[0]['registrul_comertului']}");
        $pdf->Text(10,90,"C.I.F./C.U.I.: {$getOrderInfo[0]['cod_fiscal']}");
        $pdf->Text(10,95,"Adresa: {$getOrderInfo[0]['strada']} {$getOrderInfo[0]['oras']}");
        $pdf->Text(10,100,"Cod IBAN: {$getOrderInfo[0]['cont']}");
        $pdf->Text(10,105,"CNP: {$getOrderInfo[0]['cnp']}");
        $pdf->Text(10,110,"Banca: {$getOrderInfo[0]['banca']}");
        $pdf->SetFont("Arial","",10);
        $pdf->Text(170,90,"Nr: {$getOrderInfo[0]['nr']}");
        $pdf->Text(170,95,"Data: {$getOrderInfo[0]['created_at']}");


        $pdf->SetFont("Arial","B",15);
        $pdf->SetTextColor(0,32,96);
        $pdf->Text(95,120,"Factura");

        $pdf->SetFont("Arial","",10);
        $pdf->SetTextColor(0,0,0);
        $pdf->Text(10,130,"Cota T.V.A 19%");
        $pdf->Text(10,135,"TVA la incasare");

        $x = $pdf->GetX();
        $y = $pdf->GetY();

        $pdf->ln(130);
        $pdf->SetDrawColor(16,3,3);
        $pdf->SetLineWidth(0.5);
        $pdf->SetFillColor(191,191,191);
        $pdf->SetTextColor(16,3,3);
        $pdf->MultiCell(9,7,'Nr.Crt.',1,'C',true);
        $pdf->SetXY($x + 9.2, $y + 130);
        $pdf->MultiCell(70, 14, "Denumirea produselor / a serviciilor.", 1,'C',true);
        $pdf->SetXY($x + 79.3, $y + 130);
        $pdf->MultiCell(10, 14, "U.M.", 1,'C',true);
        $pdf->SetXY($x + 89, $y + 130);
        $pdf->MultiCell(20, 14, "Cantitatea", 1,'C',true);
        $pdf->SetXY($x + 109, $y + 130);
        $pdf->MultiCell(30, 4.7, "Pret unitar\n(fara T.V.A.)\n-RON-", 1,'C',true);
        $pdf->SetXY($x + 139, $y + 130);
        $pdf->MultiCell(27, 4.7, "\nValoare\n-RON-", 1,'C',true);
        $pdf->Cell(80);
        $pdf->SetXY($x + 166, $y + 130);
        $pdf->MultiCell(25, 4.7, "Valoare\nTVA\n-RON-", 1,'C',true);
        $pdf->ln(0);
        $pdf->SetDrawColor(16,3,3);
        $pdf->SetLineWidth(0.5);
        $pdf->SetFillColor(217,217,217);
        $pdf->SetTextColor(16,3,3);

        $height = 5;
        $pdf->MultiCell(9,$height,'0',1,'C',true);
        $pdf->SetXY($x + 9.2, $y + 144);
        $pdf->MultiCell(70, $height, "1", 1,'C',true);
        $pdf->SetXY($x + 79.12, $y + 144);
        $pdf->MultiCell(10, $height, "2", 1,'C',true);
        $pdf->SetXY($x + 89, $y + 144);
        $pdf->MultiCell(20, $height, "3", 1,'C',true);
        $pdf->SetXY($x + 109, $y + 144);
        $pdf->MultiCell(30, $height, "4", 1,'C',true);
        $pdf->SetXY($x + 139, $y + 144);
        $pdf->MultiCell(27, $height, "5", 1,'C',true);
        $pdf->SetXY($x + 166, $y + 144);
        $pdf->MultiCell(25, $height, "6", 1,'C',true);
        $pdf->ln(0);
        $pdf->SetDrawColor(16,3,3);
        $pdf->SetLineWidth(0.5);
        $pdf->SetFillColor(255,255,255);
        $pdf->SetTextColor(16,3,3);



        $space = 149;
        $p_name_height = 5;
        $total_price = 0;
        $total_tva = 0;

        for($i = 0; $i < sizeof($getOrderInfo); $i++){
            $height += strlen($getOrderInfo[$i]['nume_produs']) >= 35 ? 5 : 0;

            $pdf->ln(0);
            $pdf->MultiCell(9,$height,$i+1,1,'C',true);
            $pdf->SetXY($x + 9.1, $y + $space);
            $pdf->MultiCell(70, $p_name_height, $getOrderInfo[$i]['nume_produs'], 1,'L',true);
            $pdf->SetXY($x + 79.1, $y + $space);
            $pdf->SetFont("Arial","",10);
            $pdf->MultiCell(10, $height, "RON", 1,'C',true);
            $pdf->SetXY($x + 89, $y + $space);
            $pdf->MultiCell(19.9, $height, (int)$getOrderInfo[$i]['qty_ordered'], 1,'C',true);
            $pdf->SetXY($x + 109, $y + $space);
            $pdf->MultiCell(30, $height, (int)$getOrderInfo[$i]['pret_produs'], 1,'C',true);
            $pdf->SetXY($x + 139, $y + $space);
            $pdf->MultiCell(27, $height, (int)$getOrderInfo[$i]['pret_produs'], 1,'C',true);
            $pdf->SetXY($x + 166, $y + $space);
            $pdf->MultiCell(25, $height, ($getOrderInfo[$i]['pret_produs'] * 19)/100, 1,'C',true);


            $space += strlen($getOrderInfo[$i]['nume_produs']) >= 35 ? 10 : 5;
            $height = 5;
            $total_price += $getOrderInfo[$i]['pret_produs'];
            $total_tva += ($getOrderInfo[$i]['pret_produs'] * 19)/100;
        }

        $pdf->ln(0);
        $pdf->MultiCell(65,10,"Semnatura si stampila furnizorului:\nNume:\nPrenume:\nB.I/C.I:\nC.N.P:",1,'L',true);
        $pdf->SetXY($x + 65, $y + $space);
        $pdf->MultiCell(70, 7.14, "Date privind expeditia\nNumele delegatului:.....................................\nB.I/C.I seria.............nr..................................\nMijlocul de transport:......................nr..........\nExpedierea s-a facut in prezenta noastra la\ndata de.........................ora...........................\nSemnaturile..................................................", 1,'L',true);
        $pdf->SetXY($x + 135, $y + $space);
        $pdf->MultiCell(25, 13, "Total din care:\naccize", 1,'C',true);
        $pdf->SetXY($x + 160, $y + $space);
        $pdf->MultiCell(16, 13, $total_price, 1,'C',true);
        $pdf->SetXY($x + 176, $y + $space);
        $pdf->MultiCell(15, 13, $total_tva, 1,'C',true);
        $move_first = $space + 13;
        $pdf->SetXY($x + 160, $y + $move_first);
        $pdf->MultiCell(16, 13, "", 1,'C',true);
        $pdf->SetXY($x + 176, $y + $move_first);
        $pdf->SetFont("Arial","B",10);
        $pdf->MultiCell(15, 13, "X", 1,'C',true);
        $move_second = $space + 26;
        $pdf->SetXY($x + 135, $y + $move_second);
        $pdf->SetFont("Arial","",10);
        $pdf->MultiCell(25, 12, "Semnatura de\nprimire:", 1,'L',true);
        $pdf->SetXY($x + 160, $y + $move_second);
        $t = $total_price + $total_tva;
        $pdf->MultiCell(31, 6, "Total de plata\n(RON)\n(col. 5 + 6)\n$t", 1,'C',true);





        $commandnumber = $order->getData('increment_id');
        $file_path =  "/home/marketplaceindic/public_html/app/code/KPIs/Invoice/downloadedPDF/";
        $file_name =  md5(microtime())."_$commandnumber.pdf";

        $pdf->Output("F",$file_path.$file_name);





            $mail = new \PHPMailer();
            $mail->IsSMTP();                                      // Set mailer to use SMTP
            $mail->Host = 'smtp.1and1.com';                 // Specify main and backup server
            $mail->Port = 587;                                    // Set the SMTP port
            $mail->SMTPAuth = true;                               // Enable SMTP authentication
            $mail->Username = 'info@performancemagazine.org';                // SMTP username
            $mail->Password = 'asJmr9^ac;ASX#T?';                  // SMTP password
            $mail->SMTPSecure = 'tls';                            // Enable encryption, 'ssl' also accepted

            $mail->From = 'info@performancemagazine.org';
            $mail->FromName = 'info@performancemagazine.org';
            $mail->AddAddress($getOrderInfo[0]['customer_email']);
            //$mail->AddAddress('claudiu.mitrea@kpiinstitute.com');
            $mail->IsHTML(true);                                  // Set email format to HTML

            $mail->Subject = 'Factura fiscala';
            $mail->Body    = 'Factura fiscala';
            $mail->AddAttachment( $file_path.$file_name);

            if(!$mail->Send()) {
                echo 'Mesajul nu poate fi trimis!';
                echo $mail->ErrorInfo;
                exit;
            }


//            $baseUrl = $this->storeManager->getStore()->getBaseUrl();
//            $CustomRedirectionUrl = $this->_url->getUrl($baseUrl.$_SERVER['REQUEST_URI']);
//            $this->_responseFactory->create()->setRedirect($CustomRedirectionUrl)->sendResponse();
//            $this->messageManager->addSuccessMessage("Test message!");
//            exit;


    }
}