<?php
/**
 * Copyright © 2016 x-mage2(Yosto). All rights reserved.
 * See README.md for details.
 */
namespace Yosto\CustomerAttribute\Observer;


use Magento\Customer\Model\AddressFactory;
use Magento\Framework\Event\Observer as EventObserver;
use Magento\Framework\Event\ObserverInterface;

/**
 * Class SaveCustomDataToOrderObserver
 * @package Yosto\CustomerAttribute\Observer
 */
class SaveCustomDataToOrderObserver   implements ObserverInterface
{
    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $_logger;

    /**
     * @var \Magento\Framework\ObjectManagerInterface
     */
    protected $_objectManager;

    /**
     * @var AddressFactory
     */
    protected $_addressFactory;

    /**
     * @param \Magento\Framework\ObjectManagerInterface $objectmanager
     * @param AddressFactory $addressFactory
     * @param \Psr\Log\LoggerInterface $logger
     */
    public function __construct(
        \Magento\Framework\ObjectManagerInterface $objectmanager,
        AddressFactory $addressFactory,
        \Psr\Log\LoggerInterface $logger
    ) {
        $this->_addressFactory = $addressFactory;
        $this->_logger = $logger;
        $this->_objectManager = $objectmanager;
    }

    public function execute(EventObserver $observer)
    {
        return $this;
    }
}