/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
define(
    [
        'Magento_Checkout/js/model/quote',
        'Magento_Checkout/js/model/url-builder',
        'Magento_Customer/js/model/customer',
        'Magento_Checkout/js/model/place-order'
    ],
    function (quote, urlBuilder, customer, placeOrderService) {
        'use strict';

        return function (paymentData, messageContainer) {
            var serviceUrl, payload;
            var listInputFields=[];

            if(jQuery('#payment .payment-method')){
                listInputFields = jQuery('input, select, textarea', '#payment .payment-method._active div[name^="billingAddress"]:not(._error):not([name$=".firstname"], [name$=".lastname"], [name$=".company"], [name$=".city"], [name$=".region"], [name$=".postcode"], [name$= ".country_id"], [name$=".telephone"], [name$=".region_id"], [name*=".street"])');
            }else {

                listInputFields = jQuery('input, select, textarea', 'div[name^="billingAddresscheckmo"]:not(._error):not([name$=".firstname"], [name$=".lastname"], [name$=".company"], [name$=".city"], [name$=".region"], [name$=".postcode"], [name$= ".country_id"], [name$=".telephone"], [name$=".region_id"], [name^="billingAddresscheckmo.street"])');
            }
            var jsonObj = [];

            listInputFields.each(function(){

                var name = jQuery(this).attr('name');
                var value = jQuery(this).val();

                if(jQuery(this).attr('class') == 'checkbox') {
                    if(jQuery(this).prop('checked')) {
                        value = 1;
                    } else {
                        value = 0;
                    }
                }

                var item = {};
                item['name'] = name;
                item['value'] = value;

                jsonObj.push(item);

            });
            console.log(jsonObj);
            var custom_data = JSON.stringify(jsonObj);
            var billingAddress = quote.billingAddress();
            billingAddress.extension_attributes = {custom_data: custom_data};

            payload = {
                cartId: quote.getQuoteId(),
                billingAddress: billingAddress,
                paymentMethod: paymentData
            };

            if (customer.isLoggedIn()) {
                serviceUrl = urlBuilder.createUrl('/carts/mine/payment-information', {});
            } else {
                serviceUrl = urlBuilder.createUrl('/guest-carts/:quoteId/payment-information', {
                    quoteId: quote.getQuoteId()
                });
                payload.email = quote.guestEmail;
            }

            return placeOrderService(serviceUrl, payload, messageContainer);
        };
    }
);
